@ECHO OFF
CD /d %~dp0

SET SRC_ZIP=

:EXTRACT_JDK_x64
SET JDK_EXE=
FOR %%f IN (jdk-*-windows-x64.exe) DO SET JDK_EXE=%%f
IF "%JDK_EXE%" == "" GOTO EXTRACT_JDK_i586
    CALL :GET_JDK_DIR %JDK_EXE%
    ECHO %JDK_DIR%
    
    7-Zip\7z x -y %JDK_EXE% .rsrc\1033\JAVA_CAB10\111
    7-Zip\7z x -y .rsrc\1033\JAVA_CAB10\111
    7-Zip\7z x -y -o%JDK_DIR% tools.zip > nul
    DEL /F tools.zip
    PUSHD %JDK_DIR%
    FOR /r %%x IN (*.pack) DO .\bin\unpack200 -r "%%x" "%%~dx%%~px%%~nx.jar"
    POPD
    
    7-Zip\7z x -y %JDK_EXE% .rsrc\1033\JAVA_CAB9\110
    7-Zip\7z x -y .rsrc\1033\JAVA_CAB9\110
    move /Y src.zip %JDK_DIR%\src.zip
    SET SRC_ZIP=%JDK_DIR%\src.zip
    
    rmdir /Q /S .rsrc

:EXTRACT_JDK_i586
SET JDK_EXE=
FOR %%f IN (jdk-*-windows-i586.exe) DO SET JDK_EXE=%%f
IF "%JDK_EXE%" == "" GOTO EXTRACT_JDK_END
    CALL :GET_JDK_DIR %JDK_EXE%
    ECHO %JDK_DIR%
    7-Zip\7z x -y %JDK_EXE% > nul
    7-Zip\7z x -y -o%JDK_DIR% tools.zip > nul
    DEL /F tools.zip
    PUSHD %JDK_DIR%
    FOR /r %%x IN (*.pack) DO .\bin\unpack200 -r "%%x" "%%~dx%%~px%%~nx.jar"
    POPD

    IF NOT "%SRC_ZIP%" == "" COPY "%SRC_ZIP%" %JDK_DIR%\src.zip

:EXTRACT_JDK_END
GOTO END

:GET_JDK_DIR 
SET JDK_DIR=%~n1
EXIT /b

:END
PAUSE
